# cython: language_level=3
import cython
from sqlcycli.constants import FIELD_TYPE

DECIMAL: cython.uint = FIELD_TYPE.DECIMAL  # DECIMAL
TINY: cython.uint = FIELD_TYPE.TINY  # TINYINT
SHORT: cython.uint = FIELD_TYPE.SHORT  # SMALLINT
LONG: cython.uint = FIELD_TYPE.LONG  # INT
FLOAT: cython.uint = FIELD_TYPE.FLOAT  # FLOAT
DOUBLE: cython.uint = FIELD_TYPE.DOUBLE  # DOUBLE
NULL_: cython.uint = FIELD_TYPE.NULL_
TIMESTAMP: cython.uint = FIELD_TYPE.TIMESTAMP  # TIMESTAMP
LONGLONG: cython.uint = FIELD_TYPE.LONGLONG  # BIGINT
INT24: cython.uint = FIELD_TYPE.INT24  # MEDIUMINT
DATE: cython.uint = FIELD_TYPE.DATE  # DATE
TIME: cython.uint = FIELD_TYPE.TIME  # TIME
DATETIME: cython.uint = FIELD_TYPE.DATETIME  # DATETIME
YEAR: cython.uint = FIELD_TYPE.YEAR  # YEAR
NEWDATE: cython.uint = FIELD_TYPE.NEWDATE  # DATE
VARCHAR: cython.uint = FIELD_TYPE.VARCHAR  # VARCHAR / VARBINARY
BIT: cython.uint = FIELD_TYPE.BIT  # BIT
JSON: cython.uint = FIELD_TYPE.JSON  # JSON
NEWDECIMAL: cython.uint = FIELD_TYPE.NEWDECIMAL  # DECIMAL
ENUM: cython.uint = FIELD_TYPE.ENUM  # ENUM
SET: cython.uint = FIELD_TYPE.SET  # SET
TINY_BLOB: cython.uint = FIELD_TYPE.TINY_BLOB  # TINYTEXT / TINYBLOB
MEDIUM_BLOB: cython.uint = FIELD_TYPE.MEDIUM_BLOB  # MEDIUMTEXT / MEDIUMBLOB
LONG_BLOB: cython.uint = FIELD_TYPE.LONG_BLOB  # LONGTEXT / LONGBLOB
BLOB: cython.uint = FIELD_TYPE.BLOB  # TEXT / BLOB
VAR_STRING: cython.uint = FIELD_TYPE.VAR_STRING  # VARCHAR / VARBINARY
STRING: cython.uint = FIELD_TYPE.STRING  # CHAR / BINARY
GEOMETRY: cython.uint = FIELD_TYPE.GEOMETRY  # GEOMETRY

CHAR: cython.uint = FIELD_TYPE.CHAR
INTERVAL: cython.uint = FIELD_TYPE.INTERVAL
